IRandom (GNU cryptographic primitives and tools)
Keywords: gnu.crypto.prng.IRandom,IRandom interface

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## gnu.crypto.prng
Interface IRandom

All Superinterfaces:
  java.lang.Cloneable

All Known Implementing Classes:
  BasePRNG

public interface IRandom
extends java.lang.Cloneable

The basic visible methods of any pseudo-random number generator.

The [HAC] defines a PRNG (as implemented in this library) as follows:

- "5.6 Definition: A pseudorandom bit generator (PRBG) is said to pass the next-bit test if there is no polynomial-time algorithm which, on input of the first `L` bits of an output sequence `S`, can predict the `(L+1)`st bit of `S` with a probability significantly grater than `1/2`."
- "5.8 Definition: A PRBG that passes the next-bit test (possibly under some plausible but unproved mathematical assumption such as the intractability of factoring integers) is called a cryptographically secure pseudorandom bit generator (CSPRBG)."

IMPLEMENTATION NOTE: Although all the concrete classes in this package implement the `Cloneable` interface, it is important to note here that such an operation, for those algorithms that use an underlting symmetric key block cipher, DOES NOT clone any session key material that may have been used in initialising the source PRNG (the instance to be cloned). Instead a clone of an already initialised PRNG, that uses and underlying symmetric key block cipher, is another instance with a clone of the same cipher that operates with the same block size but without any knowledge of neither key material nor key size.

References:

1. [HAC]: Handbook of Applied Cryptography.
   CRC Press, Inc. ISBN 0-8493-8523-7, 1997
   Menezes, A., van Oorschot, P. and S. Vanstone.

Method Summary
`java.lang.Object` | `clone()` Returns a clone copy of this instance.
`void` | `init(java.util.Map attributes)` Initialises the pseudo-random number generator scheme with the appropriate attributes.
`java.lang.String` | `name()` Returns the canonical name of this instance.
`byte` | `nextByte()` Returns the next 8 bits of random data generated from this instance.
`void` | `nextBytes(byte[] out, int offset, int length)` Fills the designated byte array, starting from byte at index `offset`, for a maximum of `length` bytes with the output of this generator instance.

Method Detail

### name

    public java.lang.String name()

  Returns the canonical name of this instance.

  Returns:
    the canonical name of this instance.

### init

    public void init(java.util.Map attributes)

  Initialises the pseudo-random number generator scheme with the appropriate attributes.

  Parameters:
    `attributes` - a set of name-value pairs that describe the desired future instance behaviour.
  Throws:
    `java.lang.IllegalArgumentException` - if at least one of the defined name/ value pairs contains invalid data.

### nextByte

    public byte nextByte()
                  throws java.lang.IllegalStateException,
                         LimitReachedException

  Returns the next 8 bits of random data generated from this instance.

  Returns:
    the next 8 bits of random data generated from this instance.
  Throws:
    `java.lang.IllegalStateException` - if the instance is not yet initialised.
    `LimitReachedException` - if this instance has reached its theoretical limit for generating non-repetitive pseudo-random data.

### nextBytes

    public void nextBytes(byte[] out,
                          int offset,
                          int length)
                   throws java.lang.IllegalStateException,
                          LimitReachedException

  Fills the designated byte array, starting from byte at index `offset`, for a maximum of `length` bytes with the output of this generator instance.

  Parameters:
    `out` - the placeholder to contain the generated random bytes.
    `offset` - the starting index in out to consider. This method does nothing if this parameter is not within `0` and `out.length`.
    `length` - the maximum number of required random bytes. This method does nothing if this parameter is less than `1`.
  Throws:
    `java.lang.IllegalStateException` - if the instance is not yet initialised.
    `LimitReachedException` - if this instance has reached its theoretical limit for generating non-repetitive pseudo-random data.

### clone

    public java.lang.Object clone()

  Returns a clone copy of this instance.

  Returns:
    a clone copy of this instance.

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001, 2002, 2003, 2004 Free Software Foundation, Inc.